/***********************************************************
*  mNOtBbNLCDɂ鉷xj^
*   (128x64 Dot)
*  ܂OtŃgh\
*  Project : THMonitor1
*  obt@ĝ߃Jt@C(18f26j11_ex.lkr)
************************************************************/
#include <p18f26j11.h>
#include "glcd_lib2.h"
#include <delays.h>

/* RtBM[V̐ݒ INTOSC 8MHz x PLL4 */
#pragma config OSC=INTOSCPLLO, FCMEN=OFF, IESO=OFF, WDTEN=OFF
#pragma config DSBOREN=OFF, DSWDTEN=OFF, IOL1WAY=OFF, MSSP7B_EN=MSK5 
#pragma config STVREN=OFF, LPT1OSC=OFF, XINST=OFF, T1DIG=OFF
#pragma config CP0=OFF, WPDIS=OFF
/* vg^CsO */
unsigned int GetValue(unsigned int Cur, unsigned char Chan, unsigned int Charge);
unsigned int TouchSW(unsigned char SW);
void Test(void);
void itostring(char digit, unsigned int data, char *buffer);
void Midashi(unsigned char);
void DataDisp(void);

/* f[^i[obt@` */
#define MAX	1024						// ői[
unsigned char Thermo1[MAX];			// xf[^
unsigned char Humi[MAX];				// xf[^
/* bZ[Wf[^ */
char TestMsg[]  = "Test Mode       ";
char IdleMsg[] = "Both";
char TempMsg[] = "Temparature";
char HumiMsg[] = "Humidity";
char SWMsg[] = "SW1 SW2 SW3 SW4";
char NumMsg[]   = "                    ";
char OnOffMsg[] = "                    ";
char ScrlMsg[] = "           ";
char SecMsg[] = "Sec";
char S10Msg[] = "10sec";
char MinMsg[] = "Min";
char M10Msg[] = "10min";
/* O[oϐ`  */
int Index, Scrol, Flag;
unsigned int Trip, Counter, Chik;
/* ^b`XCb`It̕Wl */
unsigned int Norm[4]={0, 0, 0, 0};
/* SWԍAN`lϊf[^ */
unsigned char SWNo[4] = {2, 3, 4, 11};
/* vԊupJE^l 0.25secP */
unsigned int Interval[4] = {4, 40, 240, 2400}; 
/* [h萔 */
enum _State{	
	IdleMode = 0,		// x\
	TempMode = 1,		// x\
	HumiMode = 2,		// x\
	TestMode = 3		// ^b`XCb`eXg
} State;

/***************** 荞݊֘A **************************/
#pragma interrupt isr0
/* 荞݃xN^Zbg */
#pragma code isrcode = 0x08
void isr_direct(void)						// 荞݊֐
{ _asm goto isr0 _endasm }				// Wv
		
/******* ^C}0̊荞ݏ 0.25sec *******/
#pragma code
void isr0(void)
{
	TMR0H = 0x85;							// ^C}0Đݒ
	TMR0L = 0xED;
	INTCONbits.TMR0IF = 0;					// 荞݃tONA
	/*** vԊũ`FbN ***/
	Counter--;							// ԃJE^XV
	if(Counter == 0){
		Counter = Interval[Chik];			// ^CAbv
		Flag = 1;						// \tOI
	}
	/***** ^b`XCb`̃`FbN@*****/
	if(TouchSW(3)){						// SW3`FbN
		State++;							// [hύX
		if(State > HumiMode)				// [hI肩H
//		if(State > TestMode)				// fobOp
			State = IdleMode;				// Idleɖ߂
		Flag = 1;
	}
	if(TouchSW(2)){						// SW2`FbN
		if(Scrol < Index - 8)				// XN[E
			Scrol += 8;					// 8TvP
		else
			Scrol = Index - 1;			// Index𒴂Ȃ悤
		Flag = 1;
	}
	if(TouchSW(1)){						// SW1`FbN
		if(Scrol > 7)						// XN[
			Scrol -= 8;					// 8TvP
		Flag = 1;
	}
	if(TouchSW(0)){						// SW0`FbN
		Chik++;							// ԊuύX
		if(Chik >= 4)						// ԊupCfbNX`FbN
			Chik = 0;
		Counter = Interval[Chik];			// ԊuXV
		Flag = 1;
	}
}

/********************* C֐@**********************/
void main(void)
{
	int i, j;
	long temp;

	/** NbNݒ **/
	OSCTUNE = 0x40;						// PLL Enable
	OSCCON = 0x70;						// use INTOSC 8MHz
	/** I/O ݒ **/
	TRISA = 0x7F;							// RA7 only output
	TRISB = 0x00;							// all output
	TRISC = 0x1C;							// I2C input
	ANCON0 = 0xE0;						// AN0-4 analog
	ANCON1 = 0x17;						// AN11 analog
	/* ^C}0ݒ  0.25sec*/
	T0CON = 0x85;							// 1:64 Fcy
	TMR0H = 0x85;							// ^C}0ݒ
	TMR0L = 0xED;
	INTCONbits.TMR0IE = 1;					// ^C}0荞݋
	// A/DRo[^ݒ	
	ADCON0 = 0x00;						// AVDD-AVSS, ADOFF CH0
	ADCON1 = 0xBE;						// Right Adj, 20TAD, Fosc/64
	ADCON0bits.ADON = 1;					// AD On
	/*@f[^obt@NA */
	for(i=0; i<MAX; i++){	
		Thermo1[i] = 0;					// xobt@
		Humi[i] = 0;						// xobt@
	}
	/* CTMU Edge1Ń}jAgK */
	CTMUCONH = 0x00;						// 10001110
	CTMUCONL = 0x90;						// 11011100
	CTMUICON = 0x01;						// Normal x1(0.55uA)
	/* ^b`XCb`ItԒl */
	for(j=0; j<10; j++){
		for(i=0; i<4; i++){				// XCb`l 5񕽋
			Norm[i] += GetValue(1, SWNo[i], 35) / 10;
			Delay1m(10);
		}
	}
	/** ϐ **/
	State = IdleMode;						// IdleMode
	Chik = 0;							// ԊupCfbNX
	Counter = Interval[Chik];				// ԃJE^Zbg
	Index = 0;							// f[^obt@pCfbNX
	Trip = 25;							// ^b`XCb`pXbVh
	Scrol = 0;							// \XN[sb`
	Flag = 1;							// \tOI
	/** LCD@**/
	lcd_Init();							// GLCD
	/* 荞݋ */
	INTCONbits.GIE = 1;					// O[o荞݋

	/************* C[v  ***********************/
	while(1){
		if(Flag){						// \vtOIH
			Flag = 0;					// tONA
			Midashi(State);				// ʌo\
			/* xf[^͂ƃobt@֕ۑ */
			ADCON0 = 0;
			ADCON0 = 0x01;				// CH0 select AD On
			ADCON0bits.GO = 1;			// AD Start
			while(ADCON0bits.DONE);		// wait
			temp = ADRESH*256+ADRESL;		// 10bit
			temp = (temp-155)*330/1024;	// XP[ϊ -10 to 50
			Thermo1[Index] = (unsigned char)(temp+10);
			/* xf[^͂ƃobt@֕ۑ */
			ADCON0 = 0;
			ADCON0 = 0x05;				// CH1 select AD On
			ADCON0bits.GO = 1;			// AD Start
			while(ADCON0bits.DONE);		// wait
			temp = ADRESH*256+ADRESL;		// 10rbgf[^擾
			temp = 108*(temp-135)/1024;	// XP[ϊ@0to100%
			/* \TCYɕϊ@100%~2/3=66Xebv@*/
			Humi[Index] = (unsigned char)((temp*2)/3);
			/* f[^\ */
			DataDisp();
			/* f[^CfbNXXV */
			Index++;
			if((Index % 128)==0){			// ʂςH
				if(Scrol < MAX-256)		// XN[XV
					Scrol +=128;
			}
			if(Index >= MAX){				// MAXTvIH
				Index = 0;				// ŏɖ߂
				Scrol = 0;
			}
		}
		/******* eXg[h̏  *****/
		if(State == TestMode){
			INTCONbits.GIE = 0;			// 荞݋֎~	
			lcd_Str(1, 1, SWMsg);			// o
			Delay1m(500);
			Test();						// eXg[hs
			Delay1m(100);
	    }
	}
}

/***********************************************
*  [hƂ̌oƍW̕\֐
***********************************************/
void Midashi(unsigned char st)
{
	int i;

	lcd_Clear(0);
	/* o̕\ */
	switch(st){
		case IdleMode:
			lcd_Str(0, 5, IdleMsg);		// \
			break;
		case TempMode :
			lcd_Str(0, 3, TempMsg);		// x\
			break;
		case HumiMode :
			lcd_Str(0, 5, HumiMsg);		// x\
			break;
		case TestMode:	
			lcd_Str(0, 0, TestMsg);		// ^b`XCb`eXg
			break;
		default: break;
	}
	/* vԊu̕\@*/
	switch(Chik){
		case 0:
			lcd_Str(7, 5, SecMsg);			// Sec
			break;
		case 1:
			lcd_Str(7, 5, S10Msg);			// 10sec
			break;
		case 2:
			lcd_Str(7, 5, MinMsg);			// Min
			break;
		case 3:
			lcd_Str(7, 5, M10Msg);			// 10min
			break;
		default: break;
	}
	/* xpW\@*/
	if((State == IdleMode)||(State == TempMode)){
		lcd_Char1(6, 0, 0x30);				// 0deg
		for(i=0; i<7; i++)
			lcd_Line(0, i*10, 5, i*10);
	}
	/* xpW\ */
	if((State == IdleMode) || (State == HumiMode)){
		lcd_Char1(4, 16, 0x34);			// 50%
		lcd_Char1(4, 17, 0x30);
		for(i=0; i<6; i++)
			lcd_Line(122, i*12, 127, i*12);			
	}
}

/**********************************************
* f[^\֐
*  XN[ʒu\Jn
**********************************************/
void DataDisp(void)
{
	int i, Offset;

	if((Index-Scrol)>128)					// XN[ʒuݒ
		Offset = 128;						// 1ʑS\
	else
		Offset = Index - Scrol;			// ŐVf[^܂ŕ\
	/* f[^\ */
	for(i=0; i<Offset; i++){				// \s
		/* x̕\ */
		if((State == IdleMode)||(State == TempMode)){
			lcd_Pixel(i, Thermo1[Scrol + i], 1);
		}
		/* x̕\ */
		if((State == IdleMode)||(State == HumiMode)){
			lcd_Pixel(i, Humi[Scrol + i], 1);
		}	
	}
}

/***************************************
* ^b`XCb`͊֐
*@p[^SWԍ
*  AN`lԍɂ͓ŕϊ
***************************************/
unsigned int TouchSW(unsigned char SW)
{
	unsigned int Vread, k;
	
	/* XCb`[dd [dԂ͗viTest()֐g) */	
	Vread = 0;
	for(k=0; k<5; k++)
		Vread += GetValue(1, SWNo[SW], 35)/5;
	/* XCb` */
	if(Vread < (Norm[SW] - Trip))			// ͔
		return(1);						// OnԂ
	else{
		Norm[SW] = (Norm[SW]+Vread)/2;		// XbVhl␳
		return(0);						// OffԂ
	}
}
/***************************************
*  CTMU ֐
*   Parameter1 FCTMUdW
*   Parameter2 FAN̓`lԍ
*   Parameter3 F[d(usec)
*   ߂l@@ Fd
***************************************/
unsigned int GetValue(unsigned int Cur, unsigned char Chan, unsigned int Charge)
{
	/* CTMU Edge1}jAgK */
	CTMUICON = Cur;						// dWݒ 	
	/* select AN channel */
	ADCON0 = 0;
	ADCON0 = Chan << 2;					// select ANx channel, Enable
	ADCON0bits.ADON = 1;
	/* discharge */
	CTMUCONHbits.CTMUEN = 1;				// enable CTMU	
	CTMUCONLbits.EDG1STAT = 0;				// gKZbg
	CTMUCONLbits.EDG2STAT = 0;
	CTMUCONHbits.IDISSEN = 1;				// dJn
	Delay1m(1);
	CTMUCONHbits.IDISSEN = 0;				// dI
	/* [dJn */
	CTMUCONLbits.EDG1STAT = 1;				// [dJn
	Delay10TCYx(Charge);					// [dԑ҂
	CTMUCONLbits.EDG1STAT = 0;				// [dI
	/* dv */
	PIR1bits.ADIF = 0;					// A/D荞݃tOZbg
	ADCON0bits.GO = 1;					// A/DϊJn
	while(!PIR1bits.ADIF);				// ϊI҂
	CTMUCONHbits.CTMUEN = 0;				// CTMU	
	return(ADRES);						// ϊʂԂ
}
/*********************************************
* Touch SW̃eXg֐
* @XCb`̑dLCDɕ\
*   𒴂Ȃ悤ɏ[dԂ𒲐
*********************************************/
void Test(void)
{
	int m;
	unsigned int Vread;

	/* XbVhlϊ */
	for(m=0; m<4; m++){
		itostring(3, Norm[m], NumMsg+(m*4)+1);
	}
	lcd_Str(2, 0, NumMsg);					// 2sڂɕ\
	/* Ɠdl̕ϊ */	 	
	for(m=0; m<4; m++){					// 4̃XCb`JԂ
		/* s */
		Vread = GetValue(1, SWNo[m], 35);	
		itostring(3, Vread, NumMsg+(m*4)+1);// ϊ
		if(Vread < (Norm[m] - Trip)){		// ͔
			OnOffMsg[m*4+1] = 'O';			// I
			OnOffMsg[m*4+2] = 'n';			// I
			OnOffMsg[m*4+3] = ' ';			// I
		}
		else{
			Norm[m] = (Norm[m]+Vread)/2;	// XbVhl␳
			OnOffMsg[m*4+1] = 'O';			// It
			OnOffMsg[m*4+2] = 'f';			// It
			OnOffMsg[m*4+3] = 'f';			// It
			OnOffMsg[m*4+4] = ' ';			// It
		}
	}
	lcd_Str(3, 0, NumMsg);					// 3sڂɕ\
	lcd_Str(4, 0, OnOffMsg);				// 4sڂɕ\
	
}
/***************************************
* ASCIIɕϊ
****************************************/
void itostring(char digit, unsigned int data, char *buffer)
{
	char i;

	buffer += digit;						// Ō̐ʒu
	for(i=digit; i>0; i--) {				// ϊ͉ʂʂ
		buffer--;						// |C^[P
		*buffer = (data % 10) + '0';		// ASCII
		data = data / 10;					// ̌
	}
}
